import java.util.*;
class qpair
{
	int ai, aj, i, j;
	public qpair(int _ai, int _aj, int _i, int _j)
	{
		this.ai = _ai;
		this.aj = _aj;
		this.i = _i;
		this.j = _j;
	}
}
class comp implements Comparator<qpair>
{
    @Override
    public int compare(qpair p1, qpair p2)
	{
		return Math.min(p1.ai, p1.aj) - Math.min(p2.ai, p2.aj);
    }
}
class pair
{
	int x, y;
	public pair(int _x, int _y)
	{
		this.x = _x;
		this.y = _y;
	}
}
class ng
{
	static int MAXN = 100000;
	static int n;
	static int[] perm = new int[MAXN];
	static boolean[] frozen = new boolean[MAXN];
	static int[] A = new int[MAXN];
	static Scanner sc = new Scanner(System.in);
	static ArrayList<qpair> pairs = new ArrayList<qpair>();
	static ArrayList<qpair> pairs2 = new ArrayList<qpair>();


	static Random rand = new Random(101);
	static void shuffle(int[] a, int n)
	{
		for (int i = 0, j, s; i < n; i++)
		{
			j = rand.nextInt(n - i);
			s = a[j];
			a[j] = a[n - i - 1];
			a[n - i - 1] = s;
		}
	}

	static pair ask(int i, int j){
		System.out.println("? " + (i + 1) + " " + (j + 1));
		int x = sc.nextInt();
		int y = sc.nextInt();
		pair r = new pair(x, y);
		return r;
	}

	static void freeze(int i, int x){
		A[i] = x;
		frozen[i] = true;
	}

	static int other(qpair p, int x, int y){
		if(Math.min(x,y) == Math.min(p.ai,p.aj) && Math.max(x,y) == Math.max(p.ai,p.aj))return -1;
		if(x == y){
			if(p.ai != x)return p.ai;
			return p.aj;
		}
		if(x != p.ai && x != p.aj){
			if(y == p.ai)return p.aj;
			return p.ai;
		}
		if(x == p.ai)return p.aj;
		return p.ai;
	}

	static void ask_pair(qpair p1, qpair p2){
		pair res = ask(p1.i, p2.i);
		int x = res.x;
		int y = res.y;
		int other1 = other(p1, x, y);
		int other2 = other(p2, x, y);
		if(other1 == -1){
			other1 = p2.ai;
			if(p2.ai == other2)other1 = p2.aj;
		}
		if(other2 == -1){
			other2 = p1.ai;
			if(p1.ai == other1)other2 = p1.aj;
		}

		if(x == y){
			freeze(p1.i, x);
			freeze(p2.i, x);
			freeze(p1.j, other1);
			freeze(p2.j, other2);
		}
		else{
			if(Math.min(p1.ai, p1.aj) != Math.min(p2.ai, p2.aj) || Math.max(p1.ai, p1.aj) != Math.max(p2.ai, p2.aj)){
				freeze(p1.j, other1);
				freeze(p2.j, other2);
				frozen[p1.i] = false;
				frozen[p2.i] = false;
				pairs2.add(new qpair(x, y, p1.i, p2.i));
			}
			else{
				pairs2.add(new qpair(x, y, p1.i, p2.i));
				pairs2.add(new qpair(x, y, p1.j, p2.j));
			}
		}
	}

	static void end_game(qpair p){
		if(p.ai == p.aj){
			freeze(p.i, p.ai);
			freeze(p.j, p.aj);
		}
		else{
			for(int k = 0; k < n; k++){
				if(A[k] == p.ai && k != p.i && k != p.j){
					int[] ind = new int[3];
					ind[0] = k;
					ind[1] = p.i;
					ind[2] = p.j;
					while(true){
						int a = rand.nextInt(2);
						int b = a + rand.nextInt(2) + 1;
						if(b == 3)b--;
						pair q = ask(ind[a], ind[b]);
						if(q.x == q.y){
							int c = 0;
							if(a == c)c = 1;
							if(b == c)c = 2;
							freeze(ind[a], p.ai);
							freeze(ind[b], p.ai);
							freeze(ind[c], p.aj);
							return;
						}
					}
				}
			}
		}
	}

	public static void main(String[] args)
	{
		n = sc.nextInt();
		for (int i = 0; i < n; i++) perm[i] = i;
		shuffle(perm, n);

		for(int c1 = 0; c1 < n; c1 += 2){
			pair p = ask(perm[c1],perm[c1+1]);
			int a = p.x;
			int b = p.y;
			if(a == b){
				freeze(perm[c1], a);
				freeze(perm[c1+1], a);
			}
			else{
				pairs.add(new qpair(a, b, perm[c1], perm[c1+1]));
			}
		}
		Collections.sort(pairs, new comp());
		for(int c1 = 0; c1 < pairs.size() - 1; c1 += 2){
			ask_pair(pairs.get(c1), pairs.get(c1+1));
		}
		if(pairs.size()%2 == 1){
			pairs2.add(pairs.get(pairs.size() - 1));
		}
		while(pairs2.size() > 1){
			qpair p1 = pairs2.get(pairs2.size() - 1);
			pairs2.remove(pairs2.size() - 1);
			qpair p2 = pairs2.get(pairs2.size() - 1);
			pairs2.remove(pairs2.size() - 1);
			ask_pair(p1,p2);
		}
		if (pairs2.size() != 0)
		{
			end_game(pairs2.get(0));
		}
		System.out.print("! ");
		for(int c1 = 0; c1 < n; c1++){
			System.out.print(A[c1] + " ");
		}
		System.out.println();
	}
}
