#!/usr/bin/env python3
import sys
import re

line = sys.stdin.readline()
assert re.match('^[1-9][0-9]*\n$', line, re.MULTILINE)
n = int(line)
assert 1 <= n <= 2 * 10**5

stars = set()
for i in range(n):
    line = sys.stdin.readline()
    assert re.match('^(0|-?[1-9][0-9]*) (0|-?[1-9][0-9]*)\n$', line, re.MULTILINE)
    x,y = map(int, line.split())
    assert -10**6 <= x <= 10**6
    assert -10**6 <= y <= 10**6
    assert (x,y) not in stars
    stars.add((x,y))

assert not sys.stdin.read()
sys.exit(42)

