#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#define MAXN 300000
#define MAXC 200000
#define rep(E, F) for (E = 0; E < (F); E++)
#define per(E, F) for (E = (F) - 1; E >= 0; E--)
#define LSB(i) ((i) & -(i))
typedef long long ll;
ll min(ll a, ll b) { if (a > b) return b; return a; }
ll max(ll a, ll b) { if (a < b) return b; return a; }
ll get_int()
{
	ll r = 0, c = getchar(), s = 1;
	while (c != '-' && c < '0' || c > '9') c = getchar();
	while (c == '-') s *= -1, c = getchar();
	while (c >= '0' && c <= '9') r = r*10 + c - '0', c = getchar();
	return s*r;
}

ll llsgn(ll x) { return x == 0 ? 0 : (x < 0 ? -1 : 1) ; }
typedef struct { ll x, y, z; } par;
void swap(ll *a, ll *b) { ll s = *a; *a = *b; *b = s; }
int opcmp(const void* p1, const void* p2)
{
	ll *a = (ll*)p1, *b = (ll*)p2, z = llsgn(a[1] - a[2]), w = llsgn(b[1] - b[2]);
	if (a[0] == b[0])
	{
		if (z == w) return z*(a[1] - b[1]);
		if (z == 0) return -1;
		if (w == 0) return 1;
		return z - w;
	}
	return a[0] - b[0];
}
int cmp(const void* p1, const void* p2)
{
	ll *a = (ll*)p1, *b = (ll*)p2;
	if (a[0] == b[0]) return a[1] - b[1];
	return a[0] - b[0];
}
ll sum(ll *a, ll i)
{ // [0, i]
    ll r = 0;
	for (i++; i > 0; i -= LSB(i)) r += a[i];
    return r;
}

void add(ll *a, ll n, ll i, ll k)
{
	for (i++; i <= n; i += LSB(i)) a[i] += k;
}

par a[MAXN], b[MAXN];
ll f[MAXN + 1], g[MAXN + 1];
ll count(ll *aa, ll *bb, ll n)
{
	ll i, j, r = 0;
	rep(i, n + 1) f[i] = g[i] = 0;
	rep(i, n) add(f, n, i, 1), add(g, n, i, 1);
	rep(i, n) a[i].x = aa[i], a[i].y = i, b[i].x = bb[i], b[i].y = i;
	qsort(a, n, sizeof *a, cmp), qsort(b, n, sizeof *b, cmp);
	rep(i, n) a[i].z = b[i].y;
	rep(i, n) b[i].y = a[i].y;
	rep(i, n) swap(&a[i].x, &a[i].y);
	qsort(a, n, sizeof *a, cmp);
	rep(i, n) swap(&a[i].x, &a[i].y);
	rep(i, n)
	{
		j = b[i].y;
		r += llabs(sum(f, a[j].z) - sum(g, j));
		add(g, n, j, -1);
		add(f, n, a[j].z, -1);
	}
	return r;
}

typedef struct { ll p[MAXN], a[MAXN], b[MAXN]; } uf;
void init(uf *u)
{
	ll i;
	rep(i, MAXN) u->p[i] = -1, u->a[i] = u->b[i] = i;
}
ll find(uf *u, ll x)
{
	return u->p[x] < 0 ? x : (u->p[x] = find(u, u->p[x]));
}
void join(uf *u, ll x, ll y)
{
	ll rx = find(u, x), ry = find(u, y);
	if (rx == ry) return;
	if (u->p[rx] > u->p[ry])
		u->a[ry] = min(u->a[ry], u->a[rx]),
		u->b[ry] = max(u->b[ry], u->b[rx]),
		u->p[ry] += u->p[rx],
		u->p[rx] = ry;
	else
		u->a[rx] = min(u->a[ry], u->a[rx]),
		u->b[rx] = max(u->b[ry], u->b[rx]),
		u->p[rx] += u->p[ry],
		u->p[ry] = rx;
}
ll ufmin(uf *u, ll x) { return u->a[find(u, x)]; }
ll ufmax(uf *u, ll x) { return u->b[find(u, x)]; }

void move_right(par* a, ll *aa, ll *c, ll n, ll x, uf *l, uf *r)
{ // move element at a[i].y in |aa| to the right
	assert(a[x].y != n - 1);
	ll k = ufmax(r, a[x].y + 1);
	printf("%lld %lld\n", a[x].y + 1, k + 1);
	swap(&aa[a[x].y], &aa[a[c[k]].y]);
	swap(&a[x].y, &a[c[k]].y);
	c[a[c[k]].y] = c[k], c[a[x].y] = x;
}

void move_left(par* a, ll *aa, ll *c, ll n, ll x, uf *l, uf *r)
{
	assert(a[x].y != 0);
	ll k = ufmin(l, a[x].y - 1);
	printf("%lld %lld\n", a[x].y + 1, k + 1);
	swap(&aa[a[x].y], &aa[a[c[k]].y]);
	swap(&a[x].y, &a[c[k]].y);
	c[a[c[k]].y] = c[k], c[a[x].y] = x;
}

uf l, r;
ll aa[MAXN], bb[MAXN], c[MAXN];
ll moves(ll *aa, ll *bb, ll n)
{ // this alters the array |aa|.
	ll i, j, k, x = 0;
	init(&l), init(&r);
	// a stores {val, curr index}
	// b stores {val, target index}
	// c stores where the ith element of aa is in a
	rep(i, n) a[i].x = aa[i], a[i].y = i, b[i].x = bb[i], b[i].y = i;
	qsort(a, n, sizeof *a, cmp), qsort(b, n, sizeof *b, cmp);
	rep(i, n) a[i].z = b[i].y;
	qsort(a, n, sizeof *a, opcmp);
	rep(i, n) c[a[i].y] = i;
	i = 0;
	while (i < n)
	{ // we need to start at the smallest guy
		rep(k, n - i) if (a[i + k].x != a[i].x) break;
		qsort(a + i, k, sizeof *a, opcmp);
		rep(j, k) c[a[i + j].y] = i + j;
		rep(j, k)
		{
			while (x < MAXC && a[i + j].y != a[i + j].z)
				a[i + j].y < a[i + j].z ? (move_right(a, aa, c, n, i + j, &l, &r)) : (move_left(a, aa, c, n, i + j, &l, &r)), x++;
			if (x == MAXC) break;
			if (a[i + j].y != 0) join(&l, a[i + j].y, a[i + j].y - 1);
			if (a[i + j].y != n - 1) join(&r, a[i + j].y, a[i + j].y + 1);
		}
		if (x == MAXC) break;
		i += k;
	}
	return x;
}

int main()
{
	ll i, j, n = get_int();
	rep(i, n) aa[i] = get_int();
	rep(i, n) bb[i] = get_int();
	printf("%lld\n", count(aa, bb, n));
	moves(aa, bb, n);
	return 0;
}

