#!/usr/bin/env python3
import argparse
import random

random.seed(123)

parser = argparse.ArgumentParser(description='Generate a test case with maximal text length.')
parser.add_argument('-n', dest='n', type=int, help='the number of words')
parser.add_argument('-w', dest='w', type=int, help='the width of the test case')
parser.add_argument('-m', dest='m', type=int, help='the length of each word')

args = parser.parse_args()

alphabet = [chr(ord('a')+k) for k in range(26)]
words = sorted([''.join(random.choices(alphabet, k=args.m)) for _ in range(args.n)])

print(args.n, args.w)
print('\n'.join(words))
