#include <algorithm>
#include <array>
#include <cassert>
#include <iostream>
#include <vector>
using namespace std;

constexpr int MAXN = 5000;

// Input data
int n, w;
vector<string> words;
vector<int> ls;

// maxl[l][r] for half open interval [l, r)
array<array<short, MAXN + 1>, MAXN + 1> maxl;

// Test a given height
bool test(int h) {
	vector<int> dp(n + 1, 1e9);
	dp[0] = 0;
	for(int i = 1; i <= n; ++i)
		for(int j = max(0, i - h); j < i; ++j) dp[i] = min(dp[i], dp[j] + maxl[j][i] + 1);
	return dp[n] <= w + 1;
}

void print(int h) {
	vector<int> dp(n + 1, 1e9);
	vector<int> p(n + 1, -1);
	dp[0] = 0;
	for(int i = 1; i <= n; ++i)
		for(int j = max(0, i - h); j < i; ++j)
			if(auto x = dp[j] + maxl[j][i] + 1; x < dp[i]) {
				dp[i] = x;
				p[i]  = j;
			}
	vector<int> as{n};
	for(int i = n; i;) as.push_back(i = p[i]);
	reverse(begin(as), end(as));
	int c = as.size() - 1;
	vector<int> ws(c);
	for(int i = 0; i < c; ++i) ws[i] = maxl[as[i]][as[i + 1]];

	vector<string> ans(h);
	for(int i = 0; i < c; ++i)
		for(int j = as[i], k = 0; k < h; ++j, ++k)
			ans[k] += j < as[i + 1] ? (words[j] + string(ws[i] + 1 - ls[j], ' '))
			                        : string(ws[i] + 1, ' ');

	cout << h << " " << c << endl;
	for(auto x : ws) cout << x << ' ';
	cout << endl;
	for(auto x : ans) cout << x << endl;
}

int main() {
	cin >> n >> w;
	words.resize(n);
	ls.reserve(n);
	for(auto& w : words) cin >> w, ls.push_back(w.size());

	// Fill maxl
	for(int l = 0; l < n; ++l)
		for(int r = l + 1, m = 0; r <= n; ++r) {
			m          = max(m, ls[r - 1]);
			maxl[l][r] = m;
		}

	int l = 1, h = n;
	while(l < h) {
		auto m = (l + h) / 2;
		std::cerr << "test " << m << endl;
		if(test(m))
			h = m;
		else
			l = m + 1;
	}
	cerr << "l: " << l << endl;
	print(l);
}
