#!/usr/bin/env python3
from collections import Counter
import random

def digit(d, k):
    s = ['','i','ii','iii','iv','v','vi','vii','viii','ix'][d]
    i, v, x = 'IVXLCDM!?'[2*k:2*k+3]
    return s.replace('x',x).replace('v',v).replace('i',i)

def roman(n):
    return ''.join([digit(int(d),k) for k,d in enumerate(str(n)[::-1])][::-1])

numbers = [roman(n) for n in range(1,4000)]
numbers = sorted(numbers, key=lambda s: -len(s))

m, d, c, l, x, v, i = map(int, input().split())
avail = Counter({'I': i, 'V': v, 'X': x, 'L': l, 'C': c, 'D': d, 'M': m})

random.seed(42)

candidates = []
for _ in range(40):
    rem = avail.copy()
    cur = dict()
    for num in numbers:
        need = Counter(num)
        take = min(rem[x]//need[x] for x in need)
        for x in need:
            rem[x] -= take*need[x]
        if take > 0:
            cur[num] = take
    if sum(rem.values()) == 0:
        candidates.append(cur)
    random.shuffle(numbers)

res = min(candidates, key=lambda cur: sum(cur.values()))

print(sum(res.values()))
print(len(res))
for x,v in res.items():
    print(x,v)
